// This code is a part of the NanoSoft NSViews C++ Library.
// Copyright (C) 1996 NanoSoft Corporation. All rights reserved.

#include "stdafx.h"
#include "NSViewsDemo.h"
#include "FlexPropertyPage4.h"
#include "NSViewsDemoDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CFlexPropertyPage4, CNSFlexPropertyPage)

BEGIN_MESSAGE_MAP(CFlexPropertyPage4, CNSFlexPropertyPage)
	//{{AFX_MSG_MAP(CFlexPropertyPage4)
	ON_EN_CHANGE(IDC_EDIT_1, OnChangeEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CFlexPropertyPage4::CFlexPropertyPage4() :
	CNSFlexPropertyPage(CFlexPropertyPage4::IDD)
{
	AddFlexConstraint(IDC_EDIT_1, NSFlexExpandRight, NSFlexExpandDown);

	//{{AFX_DATA_INIT(CFlexPropertyPage4)
	m_csEdit1 = _T("");
	//}}AFX_DATA_INIT
}

CFlexPropertyPage4::~CFlexPropertyPage4()
{

}

void CFlexPropertyPage4::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFlexPropertyPage4)
	DDX_Text(pDX, IDC_EDIT_1, m_csEdit1);
	//}}AFX_DATA_MAP
}

void CFlexPropertyPage4::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CNSViewsDemoDoc* pDoc = (CNSViewsDemoDoc*)GetDocument();
	ASSERT(pDoc);

	m_csEdit1 = pDoc->m_csTab2Edit1;

	UpdateData(FALSE);
}

void CFlexPropertyPage4::UpdateDocumentData()
{
	CNSViewsDemoDoc* pDoc = (CNSViewsDemoDoc*)GetDocument();
	ASSERT(pDoc);

	pDoc->m_csTab2Edit1 = m_csEdit1;
}

void CFlexPropertyPage4::OnChangeEdit1() 
{
	CNSViewsDemoDoc*  pDoc = (CNSViewsDemoDoc*)GetDocument();
	UpdateData();
	UpdateDocumentData();
	pDoc->SetModifiedFlag();
	pDoc->UpdateAllViews(GetView());
}
